/*
 * tmos - hello.c
 *	version 0.0.0
 *
 * Copyright (C) 2009  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <tmos/kernel.h>
#include <tmos/serial.h>

void aduc_0_process(int16_t x);
int16_t aduc_0_get(void);

static const int s[] = {
	0,
	276,
	541,
	786,
	1000,
	1176,
	1307,
	1387,
	1414,
	1387,
	1307,
	1176,
	1000,
	786,
	541,
	276,
	0,
	-276,
	-541,
	-786,
	-1000,
	-1176,
	-1307,
	-1387,
	-1414,
	-1387,
	-1307,
	-1176,
	-1000,
	-786,
	-541,
	-276,
};

static const int dither[] = {
	-0,
	1,
	0,
	0,
	0,
	-0,
	-1,
	0,
	0,
	-0,
	0,
	-0,
	-1,
	-0,
	0,
	0,
	0,
	1,
	1,
	-0,
	0,
	1,
	-0,
	-1,
	0,
	-0,
	0,
	0,
	0,
	-0,
	0,
	-0,
	1,
	0,
	0,
	0,
	-0,
	-1,
	1,
	0,
	-1,
	1,
	0,
	0,
	-0,
	-0,
	-0,
	1,
	1,
	0,
	0,
	-0,
	1,
	1,
	-0,
	0,
	-1,
	-1,
	1,
	-1,
	-0,
	0,
	-1,
	0,
	0,
	-0,
	1,
	-0,
	0,
	-0,
	-0,
	-0,
	-0,
	0,
	0,
	-0,
	-0,
	-0,
	-0,
	0,
	-0,
	-1,
	0,
	1,
	-0,
	0,
	-0,
	1,
	-0,
	0,
	-0,
	-0,
	-0,
	0,
	-0,
	-0,
	0,
	-0,
	-0,
	-1,
	0,
	0,
	0,
	0,
	0,
	1,
	-0,
	-1,
	-1,
	-1,
	-0,
	-0,
	1,
	-1,
	0,
	-1,
	-0,
	0,
	1,
	1,
	1,
	0,
	0,
	-0,
	1,
	-0,
	1,
};

int16_t gen_dither(void)
{
	static unsigned char i;

	i++;
	if (i >= ARRAY_SIZE(dither))
		i = 0;
	return dither[i];
}

int app_main(void) REENTRANT
{
	unsigned int i;
	unsigned int j;
	int16_t y;

	printk("Hello world!\n");
	for (j = 0; j < 128; j++) {
		for (i = 0; i < 32; i++) {
			int d = gen_dither();

			aduc_0_process(s[i] + d);
			y = aduc_0_get();
			printk("sin = %d\n", y);
		}
	}

	for (j = 0; j < 128; j++) {
		for (i = 0; i < 32; i++) {
			int d = gen_dither();

			aduc_0_process(0 + d);
			y = aduc_0_get();
			printk("zero = %d\n", y);
		}
	}
	PCON |= PD;
	for (;;)
		schedule();
}
