/*
 * tmos - main.c
 * 	version 0.0.0
 *
 * Copyright (C) 2005..2010  Krzysztof Mazur <krzysiek@podlesie.net>
 * Copyright (C) 2005..2010  Marek Piwonski <marek@microster.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <tmos/kernel.h>
#include <asm/system.h>
#include <tmos/watchdog.h>
#include <tmos/sched.h>
#include <asm/irqs.h>
#include <asm/delay.h>

int start_kernel(void)
{
	watchdog_init();
	call_initcalls(ARCH_INIT);
	call_initcalls(SUBSYS_INIT);

	sched_init();
	local_irq_enable();
#ifdef CONFIG_DELAY
	delay_init();
#endif

	call_initcalls(DEVICE_INIT);

	call_initcalls(LATE_INIT);

#ifdef CONFIG_APP
	return app_main();
#else
	for (;;);
#endif
}

int main(void)
{
	return arch_init();
}
