/*
 * tmos - page_zalloc.c
 *
 * Copyright (C) 2013  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include <tmos/kernel.h>
#include <asm/system.h>

/**
 * page_zalloc - allocate zeroed page
 *
 * This function returns page identifier; PAGE_NULL on error.
 */
page_t page_zalloc(void) __reentrant
{
	page_t page;

	page = page_alloc();
	if (page != PAGE_NULL)
		clear_page(page);
	return page;
}

